/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  ** This notice applies to any and all portions of this file
  * that are not between comment pairs USER CODE BEGIN and
  * USER CODE END. Other portions of this file, whether
  * inserted by the user or by software development tools
  * are owned by their respective copyright owners.
  *
  * COPYRIGHT(c) 2017 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f4xx_hal.h"

/* USER CODE BEGIN Includes */

#include "tm_stm32f4_hd44780.h"
#include "math.h"
#include <stdio.h>

/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/
SPI_HandleTypeDef hspi2;

TIM_HandleTypeDef htim3;

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/

#define SAMps   100000
#define N       10000

static volatile uint8_t necessary = 1;

char buffer[10];

uint16_t sine_buff[N];

uint16_t frequency = 1000;
uint8_t  pot_buff[2] = {125, 250};      //DC OFF & AMP values
uint8_t  pot_buff_recnt[2] = {0, 0};    //digi pot values for sending [0] = DC OFF, [1] = AMP


uint8_t  func = 1;

uint8_t  cursor = 0;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_SPI2_Init(void);
static void MX_TIM3_Init(void);

void HAL_TIM_MspPostInit(TIM_HandleTypeDef *htim);


/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

int main(void)
{

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */

  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_SPI2_Init();
  MX_TIM3_Init();

  /* USER CODE BEGIN 2 */

  //LCD Init

  //Init RW pin
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_6, RESET);
  TM_HD44780_Init(16, 2);
  TM_HD44780_Puts(0, 0, "STM32F4");
  TM_HD44780_Puts(0, 1, "Initialize");
  TM_HD44780_CursorOn();
  TM_HD44780_BlinkOn();

  //Init sine table
  sine_calc();

  HAL_Delay(1500);

  //Timer set to PWM for CS Signal to DAC
  HAL_TIM_Base_Start_IT(&htim3);
  HAL_TIM_PWM_Start(&htim3, TIM_CHANNEL_4);

  //All is Done

  TM_HD44780_CursorOff();
  TM_HD44780_BlinkOff();
  TM_HD44780_Clear();

  //Init Main Screen
  HAL_Delay(100);
  init_main_scr();

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
  /* USER CODE END WHILE */

  /* USER CODE BEGIN 3 */

    if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_0) == 0)    //Cursor Right ++
    {
        HAL_Delay(5);

        if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_0) == 0)
        {
            if(cursor < 12)
            {
                cursor++;
            }
            else
            {
                cursor = 0;
            }

            set_cursor();

            while(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_0) == 0);
        }

    }

    if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_1) == 0)    //Cursor Left --
    {
        HAL_Delay(5);

        if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_1) == 0)
        {
            if(cursor > 0)
            {
                cursor--;
            }
            else
            {
                cursor = 12;
            }

            set_cursor();

            while(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_1) == 0);
        }

    }

    if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_2) == 0)    //UP Button
    {
        HAL_Delay(5);   //Debounce

        if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_2) == 0)
        {
                switch(cursor)
                {

//==================================================================
//============================FREQUENCY=============================

                    case 1:
                        if(frequency < 19000)
                        {
                            frequency = frequency + 1000;
                        }
                        else
                        {
                            frequency = 20000;
                        }
                        out_freq();
                    break;
                    case 2:
                        if(frequency < 19900)
                        {
                            frequency = frequency + 100;
                        }
                        else
                        {
                            frequency = 20000;
                        }
                        out_freq();
                    break;
                    case 3:
                        if(frequency < 19990)
                        {
                            frequency = frequency + 10;
                        }
                        else
                        {
                            frequency = 20000;
                        }
                        out_freq();
                    break;
                    case 4:
                        if(frequency < 19999)
                        {
                            frequency = frequency + 1;
                        }
                        else
                        {
                            frequency = 20000;
                        }
                        out_freq();
                    break;

//==================================================================
//============================FUNCTION==============================

                    case 5:
                        if(func < 3)
                        {
                            func++;
                        }
                        else
                        {
                            func = 0;
                        }
                        put_func();
                    break;

//==================================================================
//============================AMPLITUDE=============================

                    case 6:
                        if(pot_buff[1] < 100)
                        {
                            pot_buff[1] = pot_buff[1] + 100;
                        }
                        else
                        {
                            pot_buff[1] = 200;
                        }
                        necessary = 1;
                        out_amp();
                    break;
                    case 7:
                        if(pot_buff[1] < 190)
                        {
                            pot_buff[1] = pot_buff[1] + 10;
                        }
                        else
                        {
                            pot_buff[1] = 200;
                        }
                        necessary = 1;
                        out_amp();
                    break;
                    case 8:
                        if(pot_buff[1] < 199)
                        {
                            pot_buff[1] = pot_buff[1] + 1;
                        }
                        else
                        {
                            pot_buff[1] = 200;
                        }
                        necessary = 1;
                        out_amp();
                    break;

//==================================================================
//============================OFFSET================================

                    case 9:
                        if(pot_buff[0] < 200)
                        {
                            pot_buff[0] = pot_buff[0] + 50;
                        }
                        else
                        {
                            pot_buff[0] = 250;
                        }
                        necessary = 1;
                        out_dc();
                    break;
                    case 10:
                        if(pot_buff[0] < 245)
                        {
                            pot_buff[0] = pot_buff[0] + 5;
                        }
                        else
                        {
                            pot_buff[0] = 250;
                        }
                        necessary = 1;
                        out_dc();
                    break;
                    case 11:
                        if(pot_buff[0] < 249)
                        {
                            pot_buff[0] = pot_buff[0] + 1;
                        }
                        else
                        {
                            pot_buff[0] = 250;
                        }
                        necessary = 1;
                        out_dc();
                    break;

//==================================================================
//============================FIRST FREQ============================

                    default:
                        if(frequency < 10000)
                        {
                            frequency = frequency + 10000;
                        }
                        else
                        {
                            frequency = 20000;
                        }
                        out_freq();
                    break;

                }

            while(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_2) == 0);
        }
    }

    if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_3) == 0)    //Down Button
    {
        HAL_Delay(5);   //Debounce

        if(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_3) == 0)
        {
                switch(cursor)
                {

//==================================================================
//============================FREQUENCY=============================

                    case 1:
                        if(frequency > 1000)
                        {
                            frequency = frequency - 1000;
                        }
                        else
                        {
                            frequency = 1;
                        }
                        out_freq();
                    break;
                    case 2:
                        if(frequency > 100)
                        {
                            frequency = frequency - 100;
                        }
                        else
                        {
                            frequency = 1;
                        }
                        out_freq();
                    break;
                    case 3:
                        if(frequency > 10)
                        {
                            frequency = frequency - 10;
                        }
                        else
                        {
                            frequency = 1;
                        }
                        out_freq();
                    break;
                    case 4:
                        if(frequency > 1)
                        {
                            frequency = frequency - 1;
                        }
                        else
                        {
                            frequency = 1;
                        }
                        out_freq();
                    break;

//==================================================================
//============================FUNCTION==============================

                    case 5:
                        if(func > 0)
                        {
                            func--;
                        }
                        else
                        {
                            func = 3;
                        }
                        put_func();
                    break;

//==================================================================
//============================AMPLITUDE=============================

                    case 6:
                        if(pot_buff[1] > 100)
                        {
                            pot_buff[1] = pot_buff[1] - 100;
                        }
                        else
                        {
                            pot_buff[1] = 0;
                        }
                        necessary = 1;
                        out_amp();
                    break;
                    case 7:
                        if(pot_buff[1] > 10)
                        {
                            pot_buff[1] = pot_buff[1] - 10;
                        }
                        else
                        {
                            pot_buff[1] = 0;
                        }
                        necessary = 1;
                        out_amp();
                    break;
                    case 8:
                        if(pot_buff[1] > 1)
                        {
                            pot_buff[1] = pot_buff[1] - 1;
                        }
                        else
                        {
                            pot_buff[1] = 0;
                        }
                        necessary = 1;
                        out_amp();
                    break;

//==================================================================
//============================OFFSET================================

                    case 9:
                        if(pot_buff[0] > 50)
                        {
                            pot_buff[0] = pot_buff[0] - 50;
                        }
                        else
                        {
                            pot_buff[0] = 0;
                        }
                        necessary = 1;
                        out_dc();
                    break;
                    case 10:
                        if(pot_buff[0] > 5)
                        {
                            pot_buff[0] = pot_buff[0] - 5;
                        }
                        else
                        {
                            pot_buff[0] = 0;
                        }
                        necessary = 1;
                        out_dc();
                    break;
                    case 11:
                        if(pot_buff[0] > 1)
                        {
                            pot_buff[0] = pot_buff[0] - 1;
                        }
                        else
                        {
                            pot_buff[0] = 0;
                        }
                        necessary = 1;
                        out_dc();
                    break;

//==================================================================
//============================FIRST FREQ============================

                    default:
                        if(frequency > 10000)
                        {
                            frequency = frequency - 10000;
                        }
                        else
                        {
                            frequency = 1;
                        }
                        out_freq();
                    break;

                }

            while(HAL_GPIO_ReadPin(GPIOD, GPIO_PIN_3) == 0);
        }
    }

  }
  /* USER CODE END 3 */

}

/** System Clock Configuration
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;

    /**Configure the main internal regulator output voltage
    */
  __HAL_RCC_PWR_CLK_ENABLE();

  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

    /**Initializes the CPU, AHB and APB busses clocks
    */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 336;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 7;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

    /**Initializes the CPU, AHB and APB busses clocks
    */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

    /**Configure the Systick interrupt time
    */
  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

    /**Configure the Systick
    */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* SPI2 init function */
static void MX_SPI2_Init(void)
{

  /* SPI2 parameter configuration*/
  hspi2.Instance = SPI2;
  hspi2.Init.Mode = SPI_MODE_MASTER;
  hspi2.Init.Direction = SPI_DIRECTION_2LINES;
  hspi2.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi2.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi2.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi2.Init.NSS = SPI_NSS_SOFT;
  hspi2.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_4;
  hspi2.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi2.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi2.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi2.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi2) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

}

/* TIM3 init function */
static void MX_TIM3_Init(void)
{

  TIM_MasterConfigTypeDef sMasterConfig;
  TIM_OC_InitTypeDef sConfigOC;

  htim3.Instance = TIM3;
  htim3.Init.Prescaler = 1;
  htim3.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim3.Init.Period = 419;
  htim3.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  if (HAL_TIM_PWM_Init(&htim3) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim3, &sMasterConfig) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 410;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_LOW;
  sConfigOC.OCFastMode = TIM_OCFAST_ENABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_4) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  HAL_TIM_MspPostInit(&htim3);

}

/** Configure pins as
        * Analog
        * Input
        * Output
        * EVENT_OUT
        * EXTI
        * Free pins are configured automatically as Analog (this feature is enabled through
        * the Code Generation settings)
     PC3   ------> I2S2_SD
     PB10   ------> I2S2_CK
     PA9   ------> USB_OTG_FS_VBUS
     PA10   ------> USB_OTG_FS_ID
     PA11   ------> USB_OTG_FS_DM
     PA12   ------> USB_OTG_FS_DP
     PC10   ------> I2S3_CK
     PC12   ------> I2S3_SD
     PB6   ------> I2C1_SCL
     PB9   ------> I2C1_SDA
*/
static void MX_GPIO_Init(void)
{

  GPIO_InitTypeDef GPIO_InitStruct;

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(CS_I2C_SPI_GPIO_Port, CS_I2C_SPI_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(OTG_FS_PowerSwitchOn_GPIO_Port, OTG_FS_PowerSwitchOn_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3
                          |GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOD, LD4_Pin|LD3_Pin|LD5_Pin|LD6_Pin
                          |Audio_RST_Pin|GPIO_PIN_7, GPIO_PIN_RESET);

  /*Configure GPIO pins : PE2 PE4 PE5 PE6
                           PE7 PE8 PE9 PE10
                           PE11 PE12 PE13 PE14
                           PE15 PE0 */
  GPIO_InitStruct.Pin = GPIO_PIN_2|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6
                          |GPIO_PIN_7|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10
                          |GPIO_PIN_11|GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_14
                          |GPIO_PIN_15|GPIO_PIN_0;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOE, &GPIO_InitStruct);

  /*Configure GPIO pin : CS_I2C_SPI_Pin */
  GPIO_InitStruct.Pin = CS_I2C_SPI_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(CS_I2C_SPI_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : PC13 PC1 PC2 PC4
                           PC8 PC11 */
  GPIO_InitStruct.Pin = GPIO_PIN_13|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_4
                          |GPIO_PIN_8|GPIO_PIN_11;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : OTG_FS_PowerSwitchOn_Pin PC5 PC6 PC7 */
  GPIO_InitStruct.Pin = OTG_FS_PowerSwitchOn_Pin|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pin : PDM_OUT_Pin */
  GPIO_InitStruct.Pin = PDM_OUT_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.Alternate = GPIO_AF5_SPI2;
  HAL_GPIO_Init(PDM_OUT_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : PA0 PA1 PA2 PA3
                           PA4 PA5 PA6 PA7 */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3
                          |GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : PB0 PB1 PB11 PB12
                           PB14 PB4 PB5 PB7
                           PB8 */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_11|GPIO_PIN_12
                          |GPIO_PIN_14|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_7
                          |GPIO_PIN_8;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : BOOT1_Pin */
  GPIO_InitStruct.Pin = BOOT1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(BOOT1_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : CLK_IN_Pin */
  GPIO_InitStruct.Pin = CLK_IN_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.Alternate = GPIO_AF5_SPI2;
  HAL_GPIO_Init(CLK_IN_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : PD8 PD9 PD10 PD11
                           PD6 */
  GPIO_InitStruct.Pin = GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_11
                          |GPIO_PIN_6;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pins : LD4_Pin LD3_Pin LD5_Pin LD6_Pin
                           Audio_RST_Pin PD7 */
  GPIO_InitStruct.Pin = LD4_Pin|LD3_Pin|LD5_Pin|LD6_Pin
                          |Audio_RST_Pin|GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pins : PA8 PA15 */
  GPIO_InitStruct.Pin = GPIO_PIN_8|GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pin : VBUS_FS_Pin */
  GPIO_InitStruct.Pin = VBUS_FS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(VBUS_FS_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : OTG_FS_ID_Pin OTG_FS_DM_Pin OTG_FS_DP_Pin */
  GPIO_InitStruct.Pin = OTG_FS_ID_Pin|OTG_FS_DM_Pin|OTG_FS_DP_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.Alternate = GPIO_AF10_OTG_FS;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : I2S3_SCK_Pin I2S3_SD_Pin */
  GPIO_InitStruct.Pin = I2S3_SCK_Pin|I2S3_SD_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.Alternate = GPIO_AF6_SPI3;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : PD0 PD1 PD2 PD3
                           OTG_FS_OverCurrent_Pin */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3
                          |OTG_FS_OverCurrent_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOD, &GPIO_InitStruct);

  /*Configure GPIO pins : Audio_SCL_Pin Audio_SDA_Pin */
  GPIO_InitStruct.Pin = Audio_SCL_Pin|Audio_SDA_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_OD;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.Alternate = GPIO_AF4_I2C1;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : MEMS_INT2_Pin */
  GPIO_InitStruct.Pin = MEMS_INT2_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_EVT_RISING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(MEMS_INT2_GPIO_Port, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

//TIM3 OCR CallBack
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim3)
{
    static uint32_t sam_num = 0, i = 0;
    uint16_t        tri_amp = 0;
    static uint8_t  buff[3] = {0, 0, 0};    // [0] = CONFIG, [1] = HIGH DATA, [2] = LOW DAT

    static uint8_t  tri_polarity;

    switch(func)
    {

        case 1:     //SINE
            if( sam_num < ( ( N* 10) - frequency - 10))
            {
                sam_num = sam_num + frequency;
            }
            else
            {
                sam_num = frequency - (( N* 10) - sam_num - 10);
            }

            buff[2] = sine_buff[ sam_num/ 10] >> 0;    //LOWER  bits
            buff[1] = sine_buff[ sam_num/ 10] >> 8;    //HIGHER bits
            //buff[0] = 0;
        break;


        case 2:     //SAW
            if(tri_polarity < 1)
            {
                if( i < ( SAMps - 2))
                {
                    i = i + 2;
                }
                else
                {
                    i = 99999;
                    tri_polarity = 1;
                }
            }

            if(tri_polarity > 0)
            {
                if( i > 1)
                {
                    i = i - 2;
                }
                else
                {
                    i = 0;
                    tri_polarity = 0;
                }
            }

            tri_amp = (i * frequency * 0.32768);

            buff[2] = tri_amp >> 0;    //LOWER  bits
            buff[1] = tri_amp >> 8;    //HIGHER bits
            //buff[0] = 0;
        break;


        case 3:     //SQUARE
            if( i < ( ( SAMps/ frequency) - 1))
            {
                i++;
            }
            else
            {
                i = 0;
            }

            if(i < (SAMps / (2 * frequency)))
            {
                buff[2] = 0xFF;    //LOWER  bits
                buff[1] = 0x7F;    //HIGHER bits
            }
            else
            {
                buff[2] = 0x00;    //LOWER  bits
                buff[1] = 0x00;    //HIGHER bits
            }

        break;


        default:    //ZERO
            buff[2] = 0;    //LOWER  bits
            buff[1] = 0;    //HIGHER bits
            //buff[0] = 0;
        break;
    }

    if(necessary == 1)  //If needs to update amplitude or offset
    {
        HAL_GPIO_WritePin(GPIOD, GPIO_PIN_7, RESET);

        HAL_SPI_Transmit(&hspi2, (uint8_t*) &pot_buff_recnt[0], 2, 2);

        HAL_GPIO_WritePin(GPIOD, GPIO_PIN_7, SET);

        necessary = 0;
    }
    else
    {
        HAL_SPI_Transmit(&hspi2, (uint8_t*) &buff[0], 3, 3);
    }
}

void sine_calc(void)
{
    uint16_t i = 0;
    float FI = 0;

    for(i = 0; i < N; i++)
    {
        FI = (( M_PI* 2)/ N)* i;

        sine_buff[i] = ( 16383 *sin( FI)) + 16383;
    }

}

void init_main_scr(void)
{
    TM_HD44780_Puts(0, 0, "f=     Hz");
    TM_HD44780_Puts(0, 1, "A= .  V O=  .  V");

    out_freq();
    out_amp();
    out_dc();

    put_func();

    set_cursor();

    TM_HD44780_CursorOn();
    TM_HD44780_BlinkOn();
}

void put_func(void)
{
    switch(func)
    {
    case 1:
        TM_HD44780_Puts(11, 0, "SINE");
    break;
    case 2:
        TM_HD44780_Puts(11, 0, "TRI ");
    break;
    case 3:
        TM_HD44780_Puts(11, 0, "SQUA");
    break;
    default:
        TM_HD44780_Puts(11, 0, "ZERO");
    break;
    }

    TM_HD44780_CursorSet(11, 0);
}

void set_cursor(void)
{
    switch(cursor)
    {
        case 1:
            TM_HD44780_CursorSet(3, 0);
        break;
        case 2:
            TM_HD44780_CursorSet(4, 0);
        break;
        case 3:
            TM_HD44780_CursorSet(5, 0);
        break;
        case 4:
            TM_HD44780_CursorSet(6, 0);
        break;
        case 5:
            TM_HD44780_CursorSet(11, 0);
        break;
        case 6:
            TM_HD44780_CursorSet(2, 1);
        break;
        case 7:
            TM_HD44780_CursorSet(4, 1);
        break;
        case 8:
            TM_HD44780_CursorSet(5, 1);
        break;
        case 9:
            TM_HD44780_CursorSet(11, 1);
        break;
        case 10:
            TM_HD44780_CursorSet(13, 1);
        break;
        case 11:
            TM_HD44780_CursorSet(14, 1);
        break;
        default:
            TM_HD44780_CursorSet(2, 0);
        break;
    }
}

void out_freq()
{
    sprintf(buffer, "%d", frequency);

    if(frequency < 10)
    {
        TM_HD44780_Puts(2, 0, "0000");
        TM_HD44780_Puts(6, 0, &buffer);
    }
    else if(frequency < 100)
    {
        TM_HD44780_Puts(2, 0, "000");
        TM_HD44780_Puts(5, 0, &buffer);
    }
    else if(frequency < 1000)
    {
        TM_HD44780_Puts(2, 0, "00");
        TM_HD44780_Puts(4, 0, &buffer);
    }
    else if(frequency < 10000)
    {
        TM_HD44780_Puts(2, 0, "0");
        TM_HD44780_Puts(3, 0, &buffer);
    }
    else
    {
        TM_HD44780_Puts(2, 0, &buffer);
    }

    set_cursor();
}

void out_amp()
{
    sprintf(buffer, "%d", pot_buff[1]/100);
    TM_HD44780_Puts(2, 1, &buffer);

    sprintf(buffer, "%d", pot_buff[1]%100);

    if(pot_buff[1]%100 < 10)
    {
        TM_HD44780_Puts(4, 1, "0");
        TM_HD44780_Puts(5, 1, &buffer);
    }
    else
    {
        TM_HD44780_Puts(4, 1, &buffer);
    }

    set_cursor();

    pot_buff_recnt[1] = pot_buff[1] * 1.275; //AMP recnt
}

void out_dc()
{
    if(pot_buff[0] > 124)
    {
        TM_HD44780_Puts(10, 1, " ");

        sprintf(buffer, "%d", ((pot_buff[0] -125)*2) /100);
        TM_HD44780_Puts(11, 1, &buffer);

        sprintf(buffer, "%d", ((pot_buff[0] -125)*2) %100);

        if((((pot_buff[0] -125)*2) %100) < 10)
        {
            TM_HD44780_Puts(13, 1, "0");
            TM_HD44780_Puts(14, 1, &buffer);
        }
        else
        {
            TM_HD44780_Puts(13, 1, &buffer);
        }
    }
    else
    {
        TM_HD44780_Puts(10, 1, "-");

        sprintf(buffer, "%d", ((125 - pot_buff[0])*2) /100);
        TM_HD44780_Puts(11, 1, &buffer);

        sprintf(buffer, "%d", ((125 - pot_buff[0])*2) %100);

        if((((125 - pot_buff[0])*2) %100) < 10)
        {
            TM_HD44780_Puts(13, 1, "0");
            TM_HD44780_Puts(14, 1, &buffer);
        }
        else
        {
            TM_HD44780_Puts(13, 1, &buffer);
        }
    }

    set_cursor();

    pot_buff_recnt[0] = pot_buff[0] * 1.02;  //DC Offset recnt
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void _Error_Handler(char * file, int line)
{
  /* USER CODE BEGIN Error_Handler_Debug */
    /* User can add his own implementation to report the HAL error return state */
    while(1)
    {
    }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */

/**
  * @}
*/

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
